//--------------------------------
// AT24C02 driver
// Author: Sadegh Mohammadi
// Date: 1391/05/06
//--------------------------------

#include "stm32f10x.h"
#include "I2C.h"
#include "USART_init_.h"
#include "Delay_.h"


//-----------------------------------------------
unsigned char Read_data(unsigned char Data_address_r)
{
	unsigned char Data_Value_r;
	I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be AT24C02
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be time
	I2C_SendData(I2C2,Data_address_r);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be AT24C02
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0xA1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	Data_Value_r = I2C_ReceiveData(I2C2);  //reading data
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);

	return Data_Value_r;
}
//-----------------------------------------------------------
void Write_data(unsigned char Data_address,unsigned char Data_Value)
{
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
		
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be AT24C02
	// Transmit the slave address and enable writing operation 
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale farmane registere marbot be time
	I2C_SendData(I2C2,Data_address); //sending address
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_SendData(I2C2,Data_Value);   // sending data for writing
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}	
		
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	// 10ms takhir ta zamani ke nevestan be tore kamel payan yabad
	Delay_ms_(10);
}


