#include "stm32f10x.h"


void I2C_Init_(void)
{
	I2C_InitTypeDef I2C_InitStruct;


	I2C_InitStruct.I2C_ClockSpeed = 300000;
	I2C_InitStruct.I2C_Mode = I2C_Mode_I2C;
	I2C_InitStruct.I2C_DutyCycle = I2C_DutyCycle_2;
	I2C_InitStruct.I2C_OwnAddress1 = 0x00;
	I2C_InitStruct.I2C_Ack = I2C_Ack_Enable;
	I2C_InitStruct.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
	I2C_Init(I2C2,&I2C_InitStruct);
	I2C_Cmd(I2C2,ENABLE);
}

void Write_Register_I2C(uint8_t RegAddr, uint16_t RegValue)
{
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere
	I2C_SendData(I2C2,RegAddr);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}

	// ersale adrese registere
	I2C_SendData(I2C2,RegValue);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
		
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
}
